/**
 * Created by julio_quispe on 04-12-14.
 */
(function($) {
    var toggle =  '[data-toggle="dropdown"]';

    var DropDown = function() {

    };

    DropDown.VERSION = '0.0.1';
    DropDown.prototype.toggle = function() {
        var $this = $(this);
        var $parent = $this.parent();
        var isActive = $parent.hasClass("open");
        clearMenu($this);
        if(isActive) {
            $parent.addClass('open');
            $parent.addClass('active');
        }
        if($parent.hasClass('disabled')) {return; }
        $parent.toggleClass('open');
        $parent.toggleClass('active');
        return false;
    };

    function clearMenu() {
        $(toggle).each(function () {
            var $this = $(this);
            var $parent = $this.parent();
            if (!$parent.hasClass('open')) { return; }
            $parent.removeClass('open');
            $parent.removeClass('active');
        });

    }


    // DROPDOWN PLUGIN DEFINITION
    // ====================
    //$.fn.dropdrownList = DropDownList.prototype.init;


    // APPLY TO DROPDOWN ELEMENTS
    // ===================================
    $(document).on('click.fe.dropdown',toggle, DropDown.prototype.toggle);
    $(document).on('click.fe.dropdown',clearMenu);




})(jQuery);